> For the complete documentation index, see [llms.txt](https://docs.umbraco.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.umbraco.com/umbraco-cms/13.latest/reference/distributed-locks.md).

# Distributed Locks

During save operations, Umbraco will generally take a database lock to avoid concurrency issues.

Access to this feature is via the `IScope` interface, for example:

```csharp
 using (var scope = _scopeProvider.CreateScope())
{
    scope.WriteLock(Constants.Locks.Domains);

    // Carry out save operation.

    scope.Complete();
}
```

Each lockable entity is represented by an integer Id, stored along with the state of the lock in the `umbracoLock` database table.

Packages or custom solutions working with custom data via the `IScope` interface can introduce their own records to this table. However it's important to not clash with either core identifiers or those introduced by other packages.

A reference is maintained here of known identifiers:

| Id           | Name                | Used By        |
| ------------ | ------------------- | -------------- |
| -1000        | MainDom             | Umbraco CMS    |
| -331 to -340 | Various             | Umbraco CMS    |
| -800         | DeployTransferQueue | Umbraco Deploy |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.umbraco.com/umbraco-cms/13.latest/reference/distributed-locks.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
